
extends _base.pug

block title
  span Easing Example

block ssvg
  input.custom-input#input(type="range" value="0")
  s-svg#ssvg
    style.
      text { fill: black; }
      rect {
        stroke: black;
        fill: red;
      }
      svg {
        width: 100%;
        max-height: 500px;
      }
    svg(width="100%" xmlns="http://www.w3.org/2000/svg" height="40vh" viewBox="0 0 1920 1200" preserveAspectRatio="xMinYMid meet")
      state.
        transition(duration="750ms")
        property(name="range" min="0" max="100" type="number" initial="0")
          relation(query-selector='#linear' attribute-name='width' from='10%' to='100%')
            transition(timing-function='linear')
          relation(query-selector='#ease' attribute-name='width' from='10%' to='100%')
            transition(timing-function='ease')
          relation(query-selector='#ease-in' attribute-name='width' from='10%' to='100%')
            transition(timing-function='ease-in')
          relation(query-selector='#ease-out' attribute-name='width' from='10%' to='100%')
            transition(timing-function='ease-out')
          relation(query-selector='#ease-in-out' attribute-name='width' from='10%' to='100%')
            transition(timing-function='ease-in-out')
          relation(query-selector='#custom' attribute-name='width' from='10%' to='100%')
            //- generate your one cubic-bezier curve
            transition(timing-function='cubic-bezier(.31,-0.36,.65,1.46)')

      svg()
        rect(id="linear" height="10%")
        text(y='8%' x='1%' font-size='60') linear
      svg(y="15%")
        rect(id="ease" height="10%")
        text(y='8%' x='1%' font-size='60') ease
      svg(y='30%')
        rect(id="ease-in" height="10%")
        text(y='8%' x='1%' font-size='60') ease-in
      svg(y='45%')
        rect(id="ease-out" height="10%")
        text(y='8%' x='1%' font-size='60') ease-out
      svg(y='60%')
        rect(id="ease-in-out" height="10%")
        text(y='8%' x='1%' font-size='60') ease-in-out
      svg(y='75%')
        rect(id="custom" height="10%")
        text(y='8%' x='1%' font-size='60') custom

  script(src=basePath + "/dist/ssvg-engine.js")
  script.
    ssvg.plugin();
    $(document).ready(() => {
      const ssvg = $('#ssvg');
      const input = $('#input');

      input.on('input', function() {
        ssvg.get(0).setState({ range: this.value });
      });
    });
